/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoEclipsePluginGen]のクラス
 */
package blanco.eclipseplugingen.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.eclipseplugingen.task.valueobject.BlancoEclipsePluginGenProcessInput;

/**
 * Apache Antタスク [BlancoEclipsePluginGen]のクラス。
 *
 * blanco FrameworkのEclipseプラグインの生成ツールです。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.eclipseplugingen.task]にBlancoEclipsePluginGenBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancoeclipseplugingen&quot; classname=&quot;blanco.eclipseplugingen.task.BlancoEclipsePluginGenTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoEclipsePluginGenTask extends Task {
    /**
     * blanco FrameworkのEclipseプラグインの生成ツールです。
     */
    protected BlancoEclipsePluginGenProcessInput fInput = new BlancoEclipsePluginGenProcessInput();

    /**
     * blanco FrameworkのEclipseプラグインの生成ツールです。
     */
    protected boolean fIsFieldMetadirProcessed = false;

    /**
     * blanco FrameworkのEclipseプラグインの生成ツールです。
     */
    protected boolean fIsFieldTargetdirProcessed = false;

    /**
     * blanco FrameworkのEclipseプラグインの生成ツールです。
     */
    protected boolean fIsFieldTmpdirProcessed = false;

    /**
     * blanco FrameworkのEclipseプラグインの生成ツールです。
     */
    protected boolean fIsFieldRootdirProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[metadir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * メタファイルが格納されるディレクトリを指定します。<br>
     *
     * @param arg セットしたい値
     */
    public void setMetadir(final String arg) {
        fInput.setMetadir(arg);
        fIsFieldMetadirProcessed = true;
    }

    /**
     * Antタスクの[metadir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * メタファイルが格納されるディレクトリを指定します。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getMetadir() {
        return fInput.getMetadir();
    }

    /**
     * Antタスクの[targetdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先フォルダを指定します。無指定の場合にはカレント直下のblancoを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetdir(final String arg) {
        fInput.setTargetdir(arg);
        fIsFieldTargetdirProcessed = true;
    }

    /**
     * Antタスクの[targetdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先フォルダを指定します。無指定の場合にはカレント直下のblancoを用います。<br>
     * デフォルト値[blanco]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetdir() {
        return fInput.getTargetdir();
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 3<br>
     * テンポラリフォルダを指定します。無指定の場合には、カレント直下のtmpを用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setTmpdir(final String arg) {
        fInput.setTmpdir(arg);
        fIsFieldTmpdirProcessed = true;
    }

    /**
     * Antタスクの[tmpdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 3<br>
     * テンポラリフォルダを指定します。無指定の場合には、カレント直下のtmpを用います。<br>
     * デフォルト値[tmp]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTmpdir() {
        return fInput.getTmpdir();
    }

    /**
     * Antタスクの[rootdir]アトリビュートのセッターメソッド。
     *
     * 項目番号: 4<br>
     * plugin.xmlファイルの出力先。無視低の場合はカレント直下を用います。<br>
     *
     * @param arg セットしたい値
     */
    public void setRootdir(final String arg) {
        fInput.setRootdir(arg);
        fIsFieldRootdirProcessed = true;
    }

    /**
     * Antタスクの[rootdir]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 4<br>
     * plugin.xmlファイルの出力先。無視低の場合はカレント直下を用います。<br>
     * デフォルト値[.]が設定されています。Apache Antタスク上でアトリビュートの指定が無い場合には、デフォルト値が設定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getRootdir() {
        return fInput.getRootdir();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoEclipsePluginGenTask begin.");

        // 項目番号[1]、アトリビュート[metadir]は必須入力です。入力チェックを行います。
        if (fIsFieldMetadirProcessed == false) {
            throw new BuildException("必須アトリビュート[metadir]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- metadir:[" + getMetadir() + "]");
            System.out.println("- targetdir:[" + getTargetdir() + "]");
            System.out.println("- tmpdir:[" + getTmpdir() + "]");
            System.out.println("- rootdir:[" + getRootdir() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoEclipsePluginGenProcessインタフェースを実装して blanco.eclipseplugingen.taskパッケージに BlancoEclipsePluginGenProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoEclipsePluginGenProcess proc = new BlancoEclipsePluginGenProcessImpl();
            if (proc.execute(fInput) != BlancoEclipsePluginGenBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
